/* $Id: th006.c 91 2004-09-16 15:02:07Z /CN=thome/emailAddress=thome@loria.fr $ */

#include <stdio.h>
#include <stdlib.h>
#include <gmp.h>
#include <math.h>
#include <assert.h>
#include <string.h>
#include <stdlib.h>

#include "mploc.h"
#include "z2.h"
#include "z2x.h"
#include "z2n.h"

int main(int argc, char *argv[])
{
	mp_size_t precision;
	int n;
	mplf_t field, myQ2n;
	mploc_t coeff_aux;
	mploc_z2x_t f;
	mploc_z2n_t test;

	n = 3;
	precision = 10;

	field = mplf_z2_create();
	mploc_z2x_init(f, field);
	mploc_z2_init(coeff_aux, field);
	mploc_z2x_set_ui(f, 1, precision);
	mploc_z2_set_ui(coeff_aux, 91, precision);
	mploc_z2x_set_coeff(f, 1, coeff_aux);
	mploc_z2_set_ui(coeff_aux, 90, precision);
	mploc_z2x_set_coeff(f, 2, coeff_aux);
	mploc_z2_set_ui(coeff_aux, 1023, precision);
	mploc_z2x_set_coeff(f, 3, coeff_aux);

	myQ2n = mplf_z2n_create(f);

	mploc_z2n_init(test, myQ2n);

	mploc_z2n_set_ui(test, 0, precision);
	return (mploc_z2n_is_zero(test)) ? 0 : 1;

	return 0;
}
