/* $Id: z2_asm.h 102 2004-09-17 15:57:35Z /CN=thome/emailAddress=thome@loria.fr $ */

#ifndef	MPLOC_ASM_H_
#define	MPLOC_ASM_H_

/* This is all the GMP stuff I need... */
#include <gmp.h>
#include <assert.h>

#include "config.h"
#include "manu.h"


#ifdef __cplusplus
extern "C" {
#endif

#include "inlining.h"

#define	MUL_NO_OVERLAP()	ASSERT(r != s1 && r != s2)
#define	SQR_NO_OVERLAP()	ASSERT(t != s)

/* This file is the entry point for the selection of all available asm
 * code. FILTER_ASM is normally not defined, so markers before asm
 * function are turned into noops.
 */
#ifndef	FILTER_ASM
#define	ASM_FUNCTION(x,v)	/**/
#endif

/************************************************************************/

#include	"common.h"

#if	defined(HAVE_HOST_CPU_FAMILY_x86) &&	\
	!defined(HAVE_HOST_CPU_FAMILY_x86_64)
#include	"x86/x86kernel.h"
#include	"x86/x86raw.h"
#include	"x86/x86inter_cset.h"
#include	"x86/x86inter.h"
/* #include	"x86/fre.h" */
#endif	/* HAVE_HOST_CPU_FAMILY_x86 */

#ifdef	HAVE_HOST_CPU_FAMILY_x86_64
#include	"x86_64/x86_64kernel.h"
#endif	/* HAVE_HOST_CPU_FAMILY_x86_64 */

#include	"fromkernel.h"

#include	"generic.h"

#include	"select.h"

#ifdef __cplusplus
}
#endif

#endif	/* MPLOC_ASM_H_ */
