/* $Id: th003.c 91 2004-09-16 15:02:07Z /CN=thome/emailAddress=thome@loria.fr $ */

#include <stdio.h>
#include <stdlib.h>
#include <gmp.h>
#include <math.h>
#include <assert.h>
#include <string.h>
#include <stdlib.h>

#include "mploc.h"
#include "z2.h"
#include "z2x.h"
#include "z2n.h"

int main(int argc, char *argv[])
{
	mp_size_t precision;
	int n;
	mploc_z2x_t V;
	mplf_t field;
	mploc_t aux;

	precision = 10;
	n = 3;

	field = mplf_z2_create();
	mploc_z2x_init(V, field);
	mploc_z2_init(aux, field);

	/* V = X + 1013*X^2 + 18*X^3 + O(2^10) */
	mploc_z2x_set_ui(V, 0, precision);
	mploc_z2_set_ui(aux, 1, precision);
	mploc_z2x_set_coeff(V, 1, aux);
	mploc_z2_set_ui(aux, 1013, precision);
	mploc_z2x_set_coeff(V, 2, aux);
	mploc_z2_set_ui(aux, 18, precision);
	mploc_z2x_set_coeff(V, 3, aux);

	/* V = V (mod 2) */
	mploc_z2x_insert_zero(V, 1);

	return 0;
}
