/* $Id: field_common.h 91 2004-09-16 15:02:07Z /CN=thome/emailAddress=thome@loria.fr $ */

#ifndef FIELD_COMMON_H_
#define FIELD_COMMON_H_

/* Internals needed for the inner field layers. */

#define UNIMPLEMENTED(x) if (1) { fprintf(stderr,"Function " x " unimplemented\n"); exit(100); }

extern void	generic_field_set(mp_limb_t *, const mp_limb_t *,
				const struct field *);
extern void	generic_field_destroy(struct field *);
extern int	generic_field_eq(mp_limb_t *,
				mp_limb_t *,
				const struct field *);
extern void	generic_field_exp(mp_limb_t *,
				const mp_limb_t *,
				const mp_limb_t *,
				const mp_size_t,
				const struct field *);

#endif	/* FIELD_COMMON_H_ */
